import copy

from SituatedObject import SituatedObject
from SituatedObject import SituatedObjectInstance
import globals

class Door(SituatedObject):
    doorPropList = {
        'AnimationState':'Integer,0-2',
        'LinkedTo':'CExoString',
        'LinkedToFlags':'Integer,0-2',
        'OnClick':'ResRef,NSS',
        'OnFailToOpen':'ResRef,NSS',
        'Appearance':'2daIndex,doortypes.2da,StringRefGame,strref,Label',
        'GenericType':'2daIndex,genericdoors.2da,Name,strref,Label',
        'LoadScreenID':'2daIndex,loadscreens.2da,StrRef,strref,Label'
        }

    def __init__ (self, gffEntry):        
        SituatedObject.__init__ (self, gffEntry)
        self.addPropList ('door', self.doorPropList, gffEntry)
        
    def getModel(self,newcopy=False):
        if not newcopy and self.model:
            return self.model
        index = self.getProperty('Appearance')[1]
        if index > 0:
            twoda = globals.resourceManager.getResourceByName('doortypes.2da')
            self.modelName = twoda.getEntry(index,'Model').lower() + '.mdl'
            self.model = globals.resourceManager.getResourceByName(self.modelName)
        else:
            index = self.getProperty('GenericType')[1]
            twoda = globals.resourceManager.getResourceByName('genericdoors.2da')
            self.modelName = twoda.getEntry(index,'ModelName').lower() + '.mdl'
            self.model = globals.resourceManager.getResourceByName(self.modelName)
        return self.model

class DoorInstance(Door,SituatedObjectInstance):

    def __init__ (self, gffEntry):
        SituatedObjectInstance.__init__ (self, gffEntry)
        Door.__init__ (self, gffEntry)
