from SituatedObject import SituatedObject
from SituatedObject import SituatedObjectInstance
from Item import ItemInstance
import copy
import globals

class Placeable(SituatedObject):
    propList = {
        'HasInventory':'Boolean',
        'OnInvDisturbed':'ResRef,NSS',
        'OnUsed':'ResRef,NSS',
        'Static':'Boolean',
        'Useable':'Boolean',
        'Appearance':'2daIndex,placeables.2da,StrRef,strref,Label',
        'BodyBag':'2daIndex,bodybag.2da,Name,strref,Label'
        }
        
    def __init__ (self, gffEntry):
        SituatedObject.__init__ (self, gffEntry)
        self.addPropList ('placeable', self.propList, gffEntry)
        

    def getInventory(self):
        if not self.getProperty('HasInventory')[1]:
            return []
        inventoryStructs = self.gffstructDict['placeable'].getInterpretedEntry('ItemList')
        if not inventoryStructs:
            return []
        return [ItemInstance(s) for s in inventoryStructs]

    def getModel(self,newcopy=False):
        if not newcopy and self.model:
            return self.model
        twoda = globals.resourceManager.getResourceByName('placeables.2da')
        index = self.getProperty('Appearance')[1]
        self.modelName = twoda.getEntry(index,'ModelName').lower() + '.mdl'
        self.model = globals.resourceManager.getResourceByName(self.modelName)
        return self.model

class PlaceableInstance(Placeable,SituatedObjectInstance):
    
    def __init__ (self, gffEntry):
        SituatedObjectInstance.__init__ (self, gffEntry)
        Placeable.__init__ (self, gffEntry)

